Subject: [PATCH 1/2] power: reset: at91: add sama5d3 reset function

From: [email-masked] (Josh Wu)
Date: Mon, 20 Jul 2015 16:44:54 +0800

On 7/20/2015 4:35 PM, Josh Wu wrote:
> Hi, Maxime
>
> On 7/20/2015 3:52 PM, Maxime Ripard wrote:
>> Hi Josh,
>>
>> On Mon, Jul 13, 2015 at 11:21:44AM +0800, Josh Wu wrote:
>>> On 7/11/2015 12:12 AM, Nicolas Ferre wrote:
>>>> Le 10/07/2015 14:31, Maxime Ripard a ?crit :
>>>>> On Fri, Jul 10, 2015 at 02:09:07PM +0200, Alexandre Belloni wrote:
>>>>>> Hi,
>>>>>>
>>>>>> On 10/07/2015 at 15:56:52 +0800, Josh Wu wrote :
>>>>>>> I would agree with Maxime. Currently all latest chip reset 
>>>>>>> function is
>>>>>>> compatible with the atmel,sama5d3-rstc.
>>>>>>> So check compatible string is enough for now.
>>>>>>> But of cause if we have other incompatible reset in future with 
>>>>>>> new chip,
>>>>>>> the structure like you said is needed.
>>>>>> We managed to avoid using of_machine_is_compatible() in all the at91
>>>>>> drivers. I'd like to keep it that way. It was painful enough to 
>>>>>> remove
>>>>>> all those cpu_is_at91xxx calls.
>>>>> That's your call...
>>>>>
>>>>>> Also, using it is trying to match strings and will result in 
>>>>>> longer boot
>>>>>> times.
>>>>> Have you looked at the implementation of of_match_device? If that's
>>>>> really a concern to you, you should actually avoid it.
>>>> I agree: let's keep it simple and use of_match_device().
>>> Ok. I will keep it as it is now:  use the (match->data != 
>>> sama5d3_restart)
>>> for the condition.
>> I'm not just that's been an option in our discussion so far.
>>
>> Nicolas said that he was agreeing with me, but at the same time said
>> the complete opposite of what I was arguing for, so I'm not really
>> sure what's really on his mind, but the two options that were
>> discussed were to remove that test, and either:
>>
>>    - Use of_device_is_compatible to prevent the loop execution
>
> Thank you for explaining, it is clear to me.
>
> I'll take this above option. As the of_device_is_compatible() almost 
> same as of_match_node()/of_match_device(). Except that 
> of_device_is_compatible() is more efficient (in this case It calls 
> __of_device_is_compatible() directly) than of_match_node/of_match_device.

Sorry, after checking the code a little, I'd say use the of_match_node 
instead of of_device_is_compatible() is better. Since After check the 
of_device_is_compatible() we also need to call of_match_node() again.

So the simplest way is just get the match data by of_match_node() first, 
then check the match->data. like following:

     match = of_match_node(at91_reset_of_match, pdev->dev.of_node);
     if (match->data != sama5d3_restart) {
         /* we need to shutdown the ddr controller, so get ramc base */
         for_each_matching_node(np, at91_ramc_of_match) {
             at91_ramc_base[idx] = of_iomap(np, 0);
             if (!at91_ramc_base[idx]) {
                 dev_err(&pdev->dev, "Could not map ram controller 
address\n");
                 return -ENODEV;
             }
             idx++;
         }
     }

     at91_restart_nb.notifier_call = match->data;

Best Regards,
Josh Wu
>
>>
>>    - define a structure with a flag to say whether you need the ram
>>      controller quirk or not, and test that flag.
>>
>> Maxime
>>
>
> Best Regards,
> Josh Wu